
* Disassembled from "RAM test.WAV"

* Wishlist for enhancements:
* - position independent code
* - check its own location too (would need dynamic relocation)
* - disable interrupts while checking RAM used by ROM IRQ routines
* - progress indicator

	org	$3e80

BANNER	fcc	/T&D SOFTWARE RAM TEST UTILITY   /
	fcc	/COPYRIGHT (C) T&D SOFTWARE 1983/
RAMOK	fcc	/RAM OK/
BADBYT	fcc	/BAD BYTE AT /
STAR	fcc	/*/

FFLAG	fcb	$00
CSTART	fdb	$0000
CEND	fdb	BANNER
DIG5	fcb	0
DIG4	fcb	0
DIG3	fcb	0
DIG2	fcb	0
DIG1	fcb	0

* Print banner
EXEC	lbsr	CLS
	ldx	#BANNER
@print	lda	,x+
	lbsr	OUTCHR
	cmpx	#RAMOK
	bne	@print
	lda	#$0d
	lbsr	OUTCHR
	lda	#$0d
	lbsr	OUTCHR

* Clear failure detected flag
	clr	>FFLAG
* Check RAM from 0 up to this program
	ldx	#$0000
	stx	>CSTART
	ldx	#BANNER
	stx	>CEND
	bsr	CHECK
* Is there RAM after this program, i.e more than 16K ?
	ldx	<$74		; pointer to end of RAM
	cmpx	#$3ffe
	beq	DONE
* Check RAM after this program
	ldx	#$4000
	stx	>CSTART
	ldx	<$74		; pointer to end of RAM
	stx	>CEND
	bsr	CHECK
* Did any address fail ?
DONE	tst	>FFLAG
	bne	RETURN
* All RAM passed
	ldx	#RAMOK
@print	lda	,x+
	lbsr	OUTCHR
	cmpx	#BADBYT
	bne	@print
	lda	#$0d
	lbsr	OUTCHR
RETURN	rts	

* RAM test routine
CHECK	ldx	>CSTART
@nbyte	lda	,x
	ldb	#$01
@nbit	stb	,x
	cmpb	,x
	bne	FAIL
	lslb	
	tstb	
	bne	@nbit
NEXT	sta	,x
	leax	1,x
	cmpx	>CEND
	bne	@nbyte
	rts	

FAIL	pshs	a,b
	pshs	x
	ldx	#BADBYT
@print	lda	,x+
	bsr	OUTCHR
	cmpx	#STAR
	bne	@print
* Convert address to decimal digits
	clr	>DIG5
	clr	>DIG4
	clr	>DIG3
	clr	>DIG2
	clr	>DIG1
	puls	x
	tfr	x,d		; failed address in D
CDIG5	subd	#10000
	bmi	DDIG5
	inc	>DIG5
	bra	CDIG5
DDIG5	addd	#10000
CDIG4	subd	#1000
	bmi	DDIG4
	inc	>DIG4
	bra	CDIG4
DDIG4	addd	#1000
CDIG3	subd	#100
	bmi	DDIG3
	inc	>DIG3
	bra	CDIG3
DDIG3	addd	#100
CDIG2	subd	#10
	bmi	DDIG2
	inc	>DIG2
	bra	CDIG2
DDIG2	addd	#10
	stb	>DIG1
* Print the five digits
	pshs	x
	ldx	#DIG5
@printd	lda	,x+
	adda	#'0
	bsr	OUTCHR
	cmpx	#EXEC
	bne	@printd
	lda	#$0d
	bsr	OUTCHR
* Set FAILED flag
	lda	#$ff
	sta	>FFLAG
	puls	x
	puls	a,b
	lbra	NEXT

OUTCHR	pshs	a,b,x,y
	clr	<$6f		; set DEVNUM = VDU
	jsr	[$a002]		; ROM OUTCHR
	puls	a,b,x,y
	rts	

CLS	ldx	#$0400
	lda	#$60
@blank	sta	,x+
	cmpx	#$0600
	bne	@blank
	ldx	#$0400
	stx	<$88		; VDU cursor pointer
	rts	

	fcb	0
	end	EXEC
