
* Based on disassembly of "RAM test.WAV"
* Made postion-independent by Tormod Volden

* Wishlist for enhancements:
* - check its own location too (would need dynamic relocation)
* - disable interrupts while checking RAM used by ROM IRQ routines
* - progress indicator

	org	$0000

	BRA	EXEC

BANNER	fcc	/T&D SOFTWARE RAM TEST UTILITY   /
	fcc	/COPYRIGHT (C) T&D SOFTWARE 1983/
	fcc	/ MODIFIED BY TORMOD VOLDEN 2013/
RAMOK	fcc	/RAM OK/
BADBYT	fcc	/BAD BYTE AT /
STAR	fcc	/*/

FFLAG	fcb	$00
CSTART	fdb	$0000
CEND	fdb	BANNER
DIG5	fcb	0
DIG4	fcb	0
DIG3	fcb	0
DIG2	fcb	0
DIG1	fcb	0

* Print banner
EXEC	lbsr	CLS
	leax	BANNER,pcr
	ldb	#RAMOK-BANNER
@print	lda	,x+
	lbsr	OUTCHR
	decb
	bne	@print
	lda	#$0d
	lbsr	OUTCHR
	lda	#$0d
	lbsr	OUTCHR

* Clear failure detected flag
	clr	FFLAG,pcr
* Check RAM from 0 up to this program
	ldx	#$0000
	stx	CSTART,pcr
	leax	BANNER,pcr
	stx	CEND,pcr
	bsr	CHECK
* Is there RAM after this program ?
	leax	EOC,pcr
	cmpx	<$74		; pointer to end of RAM
	bge	DONE
* Check RAM after this program
	stx	CSTART,pcr
	ldx	<$74		; pointer to end of RAM
	stx	CEND,pcr
	bsr	CHECK
* Did any address fail ?
DONE	tst	FFLAG,pcr
	bne	RETURN
* All RAM passed
	leax	RAMOK,pcr
	ldb	#BADBYT-RAMOK
@print	lda	,x+
	lbsr	OUTCHR
	decb
	bne	@print
	lda	#$0d
	lbsr	OUTCHR
RETURN	rts	

* RAM test routine
CHECK	ldx	CSTART,pcr
@nbyte	lda	,x
	ldb	#$01
@nbit	stb	,x
	cmpb	,x
	bne	FAIL
	lslb	
	tstb	
	bne	@nbit
NEXT	sta	,x
	leax	1,x
	cmpx	CEND,pcr
	bne	@nbyte
	rts	

FAIL	pshs	a,b
	pshs	x
	leax	BADBYT,pcr
	ldb	#STAR-BADBYT
@print	lda	,x+
	bsr	OUTCHR
	decb
	bne	@print
* Convert address to decimal digits
	clr	DIG5,pcr
	clr	DIG4,pcr
	clr	DIG3,pcr
	clr	DIG2,pcr
	clr	DIG1,pcr
	puls	x
	tfr	x,d		; failed address in D
CDIG5	subd	#10000
	bmi	DDIG5
	inc	DIG5,pcr
	bra	CDIG5
DDIG5	addd	#10000
CDIG4	subd	#1000
	bmi	DDIG4
	inc	DIG4,pcr
	bra	CDIG4
DDIG4	addd	#1000
CDIG3	subd	#100
	bmi	DDIG3
	inc	DIG3,pcr
	bra	CDIG3
DDIG3	addd	#100
CDIG2	subd	#10
	bmi	DDIG2
	inc	DIG2,pcr
	bra	CDIG2
DDIG2	addd	#10
	stb	DIG1,pcr
* Print the five digits
	pshs	x
	ldx	DIG5,pcr
	ldb	#5
@printd	lda	,x+
	adda	#'0
	bsr	OUTCHR
	decb
	bne	@printd
	lda	#$0d
	bsr	OUTCHR
* Set FAILED flag
	lda	#$ff
	sta	FFLAG,pcr
	puls	x
	puls	a,b
	lbra	NEXT

OUTCHR	pshs	a,b,x,y
	clr	<$6f		; set DEVNUM = VDU
	jsr	[$a002]		; ROM OUTCHR
	puls	a,b,x,y
	rts	

CLS	ldx	#$0400
	lda	#$60
@blank	sta	,x+
	cmpx	#$0600
	bne	@blank
	ldx	#$0400
	stx	<$88		; VDU cursor pointer
	rts	
EOC
